# This file was auto-generated by Fern from our API Definition.

from ..core.pydantic_utilities import UniversalBaseModel
import typing_extensions
import typing
from ..core.serialization import FieldMetadata
import pydantic
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class OrganizationMicrosoftTenantIDs(UniversalBaseModel):
    """
    OrganizationMicrosoftTenantIDs represents the Microsoft Tenant IDs ("TIDs")
     associated with an Organization.
    """

    organization_id: typing_extensions.Annotated[typing.Optional[str], FieldMetadata(alias="organizationId")] = (
        pydantic.Field(default=None)
    )
    """
    The ID of the Organization.
    """

    microsoft_tenant_ids: typing_extensions.Annotated[
        typing.Optional[typing.List[str]], FieldMetadata(alias="microsoftTenantIds")
    ] = pydantic.Field(default=None)
    """
    A list of Microsoft Tenant IDs associated with the organization.
    
     These values correspond to Microsoft OAuth `tid` claims:
    
     https://learn.microsoft.com/en-us/entra/identity-platform/id-token-claims-reference
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
