# This file was auto-generated by Fern from our API Definition.

from ..core.pydantic_utilities import UniversalBaseModel
import typing
import pydantic
import typing_extensions
from ..core.serialization import FieldMetadata
import datetime as dt
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class ScimapiKey(UniversalBaseModel):
    """
    SCIMAPIKey represents an API key for SCIM operations.
    """

    id: typing.Optional[str] = pydantic.Field(default=None)
    """
    The SCIM API Key ID. Starts with `scim_api_key_...`.
    """

    organization_id: typing_extensions.Annotated[typing.Optional[str], FieldMetadata(alias="organizationId")] = (
        pydantic.Field(default=None)
    )
    """
    The Organization this SCIM API Key belongs to.
    """

    create_time: typing_extensions.Annotated[typing.Optional[dt.datetime], FieldMetadata(alias="createTime")] = (
        pydantic.Field(default=None)
    )
    """
    When the SCIM API Key was created.
    """

    update_time: typing_extensions.Annotated[typing.Optional[dt.datetime], FieldMetadata(alias="updateTime")] = (
        pydantic.Field(default=None)
    )
    """
    When the SCIM API Key was last updated.
    """

    display_name: typing_extensions.Annotated[typing.Optional[str], FieldMetadata(alias="displayName")] = (
        pydantic.Field(default=None)
    )
    """
    A human-readable display name for this SCIM API Key.
    """

    secret_token: typing_extensions.Annotated[typing.Optional[str], FieldMetadata(alias="secretToken")] = (
        pydantic.Field(default=None)
    )
    """
    The secret token for this SCIM API Key.
    """

    revoked: typing.Optional[bool] = pydantic.Field(default=None)
    """
    Whether this SCIM API Key is revoked.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
