# This file was auto-generated by Fern from our API Definition.

from ..core.pydantic_utilities import UniversalBaseModel
import typing
import pydantic
import typing_extensions
from ..core.serialization import FieldMetadata
import datetime as dt
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class UserInvite(UniversalBaseModel):
    """
    UserInvite represents an invitation for a User to join an Organization.
    """

    id: typing.Optional[str] = pydantic.Field(default=None)
    """
    The User Invite ID. Starts with `user_invite_...`.
    """

    organization_id: typing_extensions.Annotated[typing.Optional[str], FieldMetadata(alias="organizationId")] = (
        pydantic.Field(default=None)
    )
    """
    The Organization this User Invite belongs to.
    """

    create_time: typing_extensions.Annotated[typing.Optional[dt.datetime], FieldMetadata(alias="createTime")] = (
        pydantic.Field(default=None)
    )
    """
    When the User Invite was created.
    """

    update_time: typing_extensions.Annotated[typing.Optional[dt.datetime], FieldMetadata(alias="updateTime")] = (
        pydantic.Field(default=None)
    )
    """
    When the User Invite was last updated.
    """

    email: typing.Optional[str] = pydantic.Field(default=None)
    """
    The invitee's email address.
    """

    owner: typing.Optional[bool] = pydantic.Field(default=None)
    """
    Indicates whether the invited User will have owner privileges in the
     Organization.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
